;Author: Kalvin Harlan
;Desc: This a Shell Expansion Program to add Trigger Keys to DoorsCS7.
;Thanks to Kerm and Zeda for the help with optimization
;and credit goes to Zeda for the optimized getKey routine.
;https://github.com/Zeda/Z80-Optimized-Routines/blob/master/ti8x/utility/getKey.z80

.nolist
#include "ti83plus.inc"
.list
        .org $86EC-13
        .dw $6DBB,$C9AB
SEStart:
        .db $31,$87,$50
        .dw 0
        .dw SEMouse-SEStart
        .dw 0
SEMouse:
        ld a,(ix+1)                        ;Set a (ix+1) (should equal zero)
        push af                             ;Push a so Key routine can use a as well.
        and a                                ;Is a=0?
        jr nz,Chain                        ;If not let's go to then Chain
GrabKey:
        ld c,1
        ld d,$FD
_:
        out (c),d
        rlc d
        jr nc,Stop
        inc e
        in a,(1)
        inc a \ jr z,-_
        dec a \ sla e
        sla e \ sla e
_:
        inc e
        rra
        jr c,-_
        ld a,e
;End of Key Routine
        ld bc,9                            ;Set's the amount of times to loop
        ld hl,vect                         ;Loads the key table into hl
        cpir                                 ;Is (hl)=a: No? inc hl \ dec bc \ try again.
        jr z,Mult                          ;Yes? Jump to Mult.
Stop:
        pop de
        ret
Mult:
        ld a,c                                ;Load the value of c into a to multiply by 5
        add a,a
        add a,a
        add a,c 
        add a,108                         ;Add 113 to get correct y coordinate for output.  
        ld (ix+0),a                        ;Save that value
Chain:
        pop af
        inc a
        ld (ix+1),a
        dec a \ jr z,Click
        dec a \ jr z,x
        dec a \ jr z,y
Reset:
        ld (ix+1),0
Click:
        ld d,2
        ret
x:
        ld d,89
        ret
y:
        ld d,(ix+0)
        ret
Vect:
        .db $1F,$1E,$19,$11
        .db $15,$25,$1D,$16
        .db $26,$FF,$00
.end